package Catmandu::Fix::marc_from_xml;
use Catmandu::Sane;
use Moo;
use Catmandu::Importer::MARC;
use Catmandu::Fix::Has;

has path  => (fix_arg => 1);

sub emit {
    my ($self,$fixer) = @_;

    my $path = $fixer->split_path($self->path);
    my $key = pop @$path;

    $fixer->emit_walk_path($fixer->var,$path,sub {
        my $var = shift;
        $fixer->emit_get_key($var,$key,sub {
            my $var = shift;
            "${var} = Catmandu::Importer::MARC->new(file => \\${var}, type => 'XML')->first();"
        });
    });
}

=head1 NAME

Catmandu::Fix::marc_from_xml - import MARCXML into a Catmandu MARC record

=head1 SYNOPSIS

=head1 DESCRIPTION

Read our Wiki pages at L<https://github.com/LibreCat/Catmandu/wiki/Fixes> for a complete
overview of the Fix language.

=head1 SEE ALSO

L<Catmandu::Fix>

=cut

1;
