<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:marc="http://www.loc.gov/MARC21/slim" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="xlink marc" version="1.0">
    <xsl:output encoding="UTF-8" indent="no" method="xml" omit-xml-declaration="yes" />
    <xsl:strip-space elements="*"/>

    <xsl:template match="/marc:record">
        <marc:record>
            <xsl:copy-of select="./marc:leader" />
            <xsl:copy-of select="./marc:controlfield" />
            <xsl:copy-of select="./marc:datafield" />
            <xsl:call-template name="marcRecordEuropeana"/>
        </marc:record>
    </xsl:template>
    <xsl:template name="createField856From940">
        <xsl:variable name="google" select="marc:subfield[@code='b']"/>
        <xsl:choose>
            <xsl:when test="$google != ''">
                <marc:datafield tag="856" ind1="4" ind2=" ">
                    <marc:subfield code="3">IsShownAt</marc:subfield>
                    <marc:subfield code="u">http://lib.ugent.be/catalog/source:bkt01?q=<xsl:value-of select="$google"/></marc:subfield>
                </marc:datafield>
                <marc:datafield tag="856" ind1="4" ind2=" ">
                    <marc:subfield code="3">Object</marc:subfield>
                    <marc:subfield code="u">http://bks1.books.google.be/books?vid=GENT<xsl:value-of select="$google" />&amp;printsec=titlepage&amp;img=1&amp;zoom=1</marc:subfield>
                </marc:datafield>
                <marc:datafield tag="540" ind1=" " ind2=" ">
                    <marc:subfield code="a">Rights Reserved - Free Access</marc:subfield>
                    <marc:subfield code="u">http://www.europeana.eu/rights/rr-f/</marc:subfield>
                </marc:datafield>
            </xsl:when>
            <xsl:otherwise>
                <marc:datafield tag="540" ind1=" " ind2=" ">
                    <marc:subfield code="a">CC BY-NC-SA (universal)</marc:subfield>
                    <marc:subfield code="u">http://creativecommons.org/licenses/by-nc-sa/3.0/</marc:subfield>
                </marc:datafield>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="createField856From024">
        <xsl:param name="fSYS"/>
        <marc:datafield tag="856" ind1="4" ind2=" ">
            <marc:subfield code="3">IsShownAt</marc:subfield>
            <marc:subfield code="u">http://lib.ugent.be/catalog/rug01:<xsl:value-of select="$fSYS"/></marc:subfield>
        </marc:datafield>
        <marc:datafield tag="856" ind1="4" ind2=" ">
            <marc:subfield code="3">IsShownBy</marc:subfield>
            <marc:subfield code="u">http://adore.ugent.be/OpenURL/resolve?rft_id=<xsl:value-of select="marc:subfield[@code='a']"/>:1&amp;svc_id=Large&amp;url_ver=Z39.88-2004</marc:subfield>
        </marc:datafield>
        <marc:datafield tag="856" ind1="4" ind2=" ">
            <marc:subfield code="3">Object</marc:subfield>
            <marc:subfield code="u">http://adore.ugent.be/OpenURL/resolve?rft_id=<xsl:value-of select="marc:subfield[@code='a']"/>:1&amp;svc_id=Thumbnail&amp;url_ver=Z39.88-2004</marc:subfield>
        </marc:datafield>
    </xsl:template>
    <xsl:template name="marcRecordEuropeana">
        <xsl:variable name="fSYS" select="marc:controlfield[@tag='001']"/>
        <xsl:for-each select="marc:datafield[@tag='024']">
            <xsl:call-template name="createField856From024">
                <xsl:with-param name="fSYS" select="$fSYS"/>
            </xsl:call-template>
        </xsl:for-each>
        <xsl:for-each select="marc:datafield[@tag='940']">
            <xsl:call-template name="createField856From940"/>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>
